import { Base, Nullable$1, Type } from "igniteui-webcomponents-core";
import { IWorkbookFont } from "igniteui-webcomponents-excel";
import { IGFormattedTextSettings } from "./IGFormattedTextSettings";
import { WorkbookColorInfo } from "igniteui-webcomponents-excel";
import { FontSuperscriptSubscriptStyle } from "igniteui-webcomponents-excel";
import { FontUnderlineStyle } from "igniteui-webcomponents-excel";
/**
 * @hidden
 */
export declare class IGFormattedTextFont extends Base implements IWorkbookFont {
    static $t: Type;
    _a: IGFormattedTextSettings;
    private _b;
    bold: boolean | null;
    _bold$i: Nullable$1<boolean>;
    colorInfo: WorkbookColorInfo;
    height: number;
    italic: boolean | null;
    _italic$i: Nullable$1<boolean>;
    name: string;
    strikeout: boolean | null;
    _strikeout$i: Nullable$1<boolean>;
    superscriptSubscriptStyle: FontSuperscriptSubscriptStyle;
    underlineStyle: FontUnderlineStyle;
    setFontFormatting(a: IWorkbookFont): void;
}
