import { Base, Nullable$1, Type } from "igniteui-webcomponents-core";
import { IWorksheetCellFormat } from "igniteui-webcomponents-excel";
import { HorizontalCellAlignment } from "igniteui-webcomponents-excel";
import { WorksheetCellFormatData } from "igniteui-webcomponents-excel";
import { WorkbookColorInfo } from "igniteui-webcomponents-excel";
import { CellBorderLineStyle } from "igniteui-webcomponents-excel";
import { DiagonalBorders } from "igniteui-webcomponents-excel";
import { CellFill } from "igniteui-webcomponents-excel";
import { IWorkbookFont } from "igniteui-webcomponents-excel";
import { WorksheetCellFormatOptions } from "igniteui-webcomponents-excel";
import { WorkbookStyle } from "igniteui-webcomponents-excel";
import { VerticalCellAlignment } from "igniteui-webcomponents-excel";
/**
 * @hidden
 */
export declare class ReadOnlyResolvedWorksheetCellFormatData extends Base implements IWorksheetCellFormat {
    static $t: Type;
    private _b;
    private _a;
    constructor(a: WorksheetCellFormatData);
    _c(a: WorksheetCellFormatData): void;
    setFormatting(a: IWorksheetCellFormat): void;
    alignment: HorizontalCellAlignment;
    bottomBorderColorInfo: WorkbookColorInfo;
    bottomBorderStyle: CellBorderLineStyle;
    diagonalBorderColorInfo: WorkbookColorInfo;
    diagonalBorders: DiagonalBorders;
    diagonalBorderStyle: CellBorderLineStyle;
    fill: CellFill;
    readonly font: IWorkbookFont;
    formatOptions: WorksheetCellFormatOptions;
    formatString: string;
    indent: number;
    leftBorderColorInfo: WorkbookColorInfo;
    leftBorderStyle: CellBorderLineStyle;
    locked: boolean | null;
    _locked$i: Nullable$1<boolean>;
    rightBorderColorInfo: WorkbookColorInfo;
    rightBorderStyle: CellBorderLineStyle;
    rotation: number;
    shrinkToFit: boolean | null;
    _shrinkToFit$i: Nullable$1<boolean>;
    style: WorkbookStyle;
    topBorderColorInfo: WorkbookColorInfo;
    topBorderStyle: CellBorderLineStyle;
    verticalAlignment: VerticalCellAlignment;
    wrapText: boolean | null;
    _wrapText$i: Nullable$1<boolean>;
}
